<?php
jimport('joomla.plugin.plugin');
class plgSystemCustom_quantity_tax extends JPlugin{

}
class plgSystemCustom_quantity_taxHelper{

	function quantityPrices(&$prices,$quantity,$total_quantity){
		//we cannot select prices before currency conversion because a main product price can be used by different variants with a different quantity than the main one so we first need to sort out the variant fields data and thus we need to get the prices before
		$this->pricesSelection($prices,$total_quantity);
		$unitPrice = null;
		if(!empty($prices)){
			//if we found at least a price we need to select the one to use (the lowest one)
			$unitPrice = reset($prices);
			if(count($prices)>1){
				$cheapest_value=$unitPrice->price_value;
				foreach($prices as $price){
					if($cheapest_value>$price->price_value){
						$unitPrice = $price;
						$cheapest_value = $price->price_value;
					}
				}
			}

			//after selecting it, we generate the quantity price
			$this->quantityPrice($unitPrice,$quantity);
			$prices = array($unitPrice);
		}
	}
	function pricesSelection(&$prices,$quantity){
		$matches=array();
		$otherCurrencies=array();
		if(!empty($prices)){
			foreach($prices as $k2 => $price){
				//do not use prices if the minimum quantity is not reached
				if($price->price_min_quantity>$quantity) continue;
				//get a list of the prices with the good currency
				//if there is an orig currency, it means that the price had to be converted and thus was not in the good currency
				if(empty( $price->price_orig_currency_id)){
					$matches[]=$price;
				}else{
					$otherCurrencies[]=$price;
				}
			}
		}
		if(empty($matches) && !empty($otherCurrencies)){
			$config =& hikashop_config();
			$main_currency = (int)$config->get('main_currency',1);
			//if we didn't found any prices in the good currency we choose another currency (the main one preferably)
			foreach($otherCurrencies as $price){
				if($price->price_orig_currency_id==$main_currency){
					$matches[]=$price;
				}
			}
			if(empty($matches)){
				$matches = $otherCurrencies;
			}
		}
		$prices = $matches;
	}
	function quantityPrice(&$price,$quantity){
		if($quantity>0){
			$currencyHelper = hikashop_get('class.currency');
			$price->unit_price->price_currency_id = $price->price_currency_id;
			$rounding = $currencyHelper->getRounding($price->price_currency_id);
			if(isset($price->price_orig_currency_id)){
				$price->unit_price->price_orig_currency_id = $price->price_orig_currency_id;
			}
			if(isset($price->price_value_without_discount)){
				$price->unit_price->price_value_without_discount=round($price->price_value_without_discount,$rounding);
				$price->price_value_without_discount=round($price->unit_price->price_value_without_discount*$quantity,$rounding);
			}
			if(isset($price->price_value)){
				$price->unit_price->price_value=round($price->price_value,$rounding);
				$price->price_value=round($price->unit_price->price_value*$quantity,$rounding);
			}
			if(isset($price->price_orig_value)){
				$price->unit_price->price_orig_value=round($price->price_orig_value,$rounding);
				$price->price_orig_value=round($price->unit_price->price_orig_value*$quantity,$rounding);
			}
			if(isset($price->price_orig_value_with_tax)){
				$price->unit_price->price_orig_value_with_tax=round($price->price_orig_value_with_tax,$rounding);
				$price->price_orig_value_with_tax=$currencyHelper->getTaxedPrice($price->unit_price->price_orig_value*$quantity,hikashop_getZone(),$this->product->product_tax_id,$rounding);
				//$price->price_orig_value_with_tax=round($price->unit_price->price_orig_value_with_tax*$quantity,$rounding);
			}
			if(isset($price->price_orig_value_without_discount)){
				$price->unit_price->price_orig_value_without_discount=round($price->price_orig_value_without_discount,$rounding);
				$price->price_orig_value_without_discount=round($price->unit_price->price_orig_value_without_discount*$quantity,$rounding);
			}
			if(isset($price->price_value_without_discount_with_tax)){
				$price->unit_price->price_value_without_discount_with_tax=round($price->price_value_without_discount_with_tax,$rounding);
				$price->price_value_without_discount_with_tax=$currencyHelper->getTaxedPrice($price->unit_price->price_value_without_discount*$quantity,hikashop_getZone(),$this->product->product_tax_id,$rounding);
				//$price->price_value_without_discount_with_tax=round($price->unit_price->price_value_without_discount_with_tax*$quantity,$rounding);
			}
			if(isset($price->price_value_with_tax)){
				$price->unit_price->price_value_with_tax=round($price->price_value_with_tax,$rounding);

				$price->price_value_with_tax=$currencyHelper->getTaxedPrice($price->unit_price->price_value*$quantity,hikashop_getZone(),$this->product->product_tax_id,$rounding);
				//$price->price_value_with_tax=round($price->unit_price->price_value_with_tax*$quantity,$rounding);
			}
		}
	}
}
function hikashop_product_price_for_quantity_in_cart(&$product){

	$quantity = @$product->cart_product_quantity;
	$custom = new plgSystemCustom_quantity_taxHelper();
	$custom->product =& $product;
	$custom->quantityPrices($product->prices,$quantity,$product->cart_product_total_quantity);
}
